package query

import (
	"context"
	"encoding/json"
	"gd_adm_data/apis"
	"gd_adm_data/errors"
	"gd_adm_data/utils"
	"strings"
	"time"

	jsoniter "github.com/json-iterator/go"
)

// 计算最后投保日期
func calcLatestInsuredate(reqMap map[string]interface{}) {
	retLen := utils.MonthLen
	firstInsuranceDate := ""
	lastCompulsoryInsuranceDate := ""

	if v, ok := reqMap["first_insurance_date"]; ok {
		firstInsuranceDate = v.(string)
	}

	if v, ok := reqMap["last_compulsory_insurance_date"]; ok {
		lastCompulsoryInsuranceDate = v.(string)
	}

	if firstInsuranceDate == "" && lastCompulsoryInsuranceDate == "" {
		return
	}

	latestInsuranceDateStart := ""

	lastCompulsoryInsuranceDate = strings.TrimSpace(lastCompulsoryInsuranceDate)
	firstInsuranceDate = strings.TrimSpace(firstInsuranceDate)

	if lastCompulsoryInsuranceDate == "" {
		return
	} else if firstInsuranceDate == "" {
		latestInsuranceDateStart = lastCompulsoryInsuranceDate
	} else if len(lastCompulsoryInsuranceDate) < utils.MonthLen ||
		len(firstInsuranceDate) < utils.MonthLen {
		return
	} else if lastCompulsoryInsuranceDate[utils.MonthLen-2:utils.MonthLen] == firstInsuranceDate[utils.MonthLen-2:utils.MonthLen] {
		if len(firstInsuranceDate) == utils.DataLen {
			latestInsuranceDateStart = lastCompulsoryInsuranceDate + firstInsuranceDate[7:]
			retLen = utils.DataLen
		} else {
			latestInsuranceDateStart = lastCompulsoryInsuranceDate
		}

	} else {
		latestInsuranceDateStart = lastCompulsoryInsuranceDate
	}

	latestInsuranceDateStart = strings.TrimSpace(latestInsuranceDateStart)
	if len(latestInsuranceDateStart) > utils.DataLen {
		latestInsuranceDateStart = latestInsuranceDateStart[:utils.DataLen]
	} else if len(latestInsuranceDateStart) == utils.MonthLen {
		latestInsuranceDateStart = latestInsuranceDateStart + "-01"
	}

	latestInsuranceDateStartTime, _ := time.Parse(utils.DayLayout, latestInsuranceDateStart)
	latestInsuranceDateEnd := latestInsuranceDateStartTime.AddDate(1, 0, 0).String()[:retLen]
	reqMap["latest_insurance_date_end"] = latestInsuranceDateEnd
	reqMap["latest_nsurance_date_start"] = latestInsuranceDateStart
}

// 格式化数据
func F01(ctx context.Context, params string) (reply *apis.QueryResponse, err error) {
	reply = &apis.QueryResponse{}

	reply.Data = params
	reqMap := make(map[string]interface{})
	err = json.Unmarshal([]byte(params), &reqMap)
	if err != nil {
		return reply, errors.ParamsError
	}
	// 格式化数据
	formatData(reqMap)

	reply.Data, _ = jsoniter.MarshalToString(reqMap)

	return reply, nil
}
