package query

import (
	"context"
	"gd_adm_data/apis"
	"strings"

	"gd_adm_data/errors"
)

func Query(ctx context.Context, req *apis.QueryRequest, reply *apis.QueryResponse) (err error) {
	interfaces := map[string]func(ctx context.Context, params string) (reply *apis.QueryResponse, err error){
		"P01":  P01,
		"P02":  P02,
		"P03":  P03,
		"P04":  P04,
		"P05":  P05,
		"P06":  P06,
		"P07":  P07,
		"P08":  P08,
		"P09":  P09,
		"P10":  P10,
		"A01":  A01,
		"A02":  A02,
		"A03":  A03,
		"V01":  V01,
		"IS01": IS01,
		"V02":  V02,
		"U01":  U01,
		"U02":  U02,
		"A04":  A04,
		"A05":  A05,
		"P11":  P11,
		"F01":  F01,
	}

	code := strings.ToUpper(req.Code)
	if v, ok := interfaces[code]; ok {
		vreply, err := v(ctx, req.Params)
		if err != nil {
			return err
		}

		reply.Data = vreply.Data
		/*if code == "U01" {
			return nil
		}

		uReply, uerr := U01(ctx, reply.Data)
		if uerr == nil {
			reply.Data = uReply.Data
		}*/
		return nil
	}

	return errors.InterfaceNoExistError
}
